diff --git a/packages/code-generator/src/publisher/disk/utils.ts b/packages/code-generator/src/publisher/disk/utils.ts
index b07cb83c9..2f12d1bdf 100644
--- a/packages/code-generator/src/publisher/disk/utils.ts
+++ b/packages/code-generator/src/publisher/disk/utils.ts
@@ -1,58 +1,53 @@
-import { existsSync, mkdir, writeFile } from 'fs';
+import * as systemFs from 'fs';
 import { join } from 'path';
+import { ResultDir, ResultFile } from '@ali/lowcode-types';
 
-import { IResultDir, IResultFile } from '../../types';
+export interface IFileSystem {
+  existsSync: typeof systemFs.existsSync;
+  mkdir: typeof systemFs.mkdir;
+  writeFile: typeof systemFs.writeFile;
+}
 
 export const writeFolder = async (
-  folder: IResultDir,
+  folder: ResultDir,
   currentPath: string,
   createProjectFolder = true,
+  fs: IFileSystem = systemFs,
 ): Promise<void> => {
   const { name, files, dirs } = folder;
 
-  const folderPath = createProjectFolder
-    ? join(currentPath, name)
-    : currentPath;
+  const folderPath = createProjectFolder ? join(currentPath, name) : currentPath;
 
-  if (!existsSync(folderPath)) {
-    await createDirectory(folderPath);
+  if (!fs.existsSync(folderPath)) {
+    await createDirectory(folderPath, fs);
   }
 
-  const promises = [
-    writeFilesToFolder(folderPath, files),
-    writeSubFoldersToFolder(folderPath, dirs),
-  ];
+  const promises = [writeFilesToFolder(folderPath, files, fs), writeSubFoldersToFolder(folderPath, dirs, fs)];
 
   await Promise.all(promises);
 };
 
-const writeFilesToFolder = async (
-  folderPath: string,
-  files: IResultFile[],
-): Promise<void> => {
-  const promises = files.map(file => {
+const writeFilesToFolder = async (folderPath: string, files: ResultFile[], fs: IFileSystem): Promise<void> => {
+  const promises = files.map((file) => {
     const fileName = file.ext ? `${file.name}.${file.ext}` : file.name;
     const filePath = join(folderPath, fileName);
-    return writeContentToFile(filePath, file.content);
+    return writeContentToFile(filePath, file.content, 'utf8', fs);
   });
 
   await Promise.all(promises);
 };
 
-const writeSubFoldersToFolder = async (
-  folderPath: string,
-  subFolders: IResultDir[],
-): Promise<void> => {
-  const promises = subFolders.map(subFolder => {
+const writeSubFoldersToFolder = async (folderPath: string, subFolders: ResultDir[]): Promise<void> => {
+  const promises = subFolders.map((subFolder) => {
     return writeFolder(subFolder, folderPath);
   });
 
   await Promise.all(promises);
 };
 
-const createDirectory = (pathToDir: string): Promise<void> => {
+const createDirectory = (pathToDir: string, fs: IFileSystem): Promise<void> => {
   return new Promise((resolve, reject) => {
-    mkdir(pathToDir, { recursive: true }, err => {
+    fs.mkdir(pathToDir, { recursive: true }, (err) => {
       err ? reject(err) : resolve();
     });
   });
@@ -62,9 +57,10 @@ const writeContentToFile = (
   filePath: string,
   fileContent: string,
   encoding = 'utf8',
+  fs: IFileSystem,
 ): Promise<void> => {
   return new Promise((resolve, reject) => {
-    writeFile(filePath, fileContent, encoding, err => {
+    fs.writeFile(filePath, fileContent, encoding, (err) => {
       err ? reject(err) : resolve();
     });
   });
diff --git a/packages/code-generator/src/publisher/zip/index.ts b/packages/code-generator/src/publisher/zip/index.ts
index 9e2cbe36f..2048a54cf 100644
--- a/packages/code-generator/src/publisher/zip/index.ts
+++ b/packages/code-generator/src/publisher/zip/index.ts
@@ -1,10 +1,5 @@
-import {
-  IResultDir,
-  PublisherFactory,
-  IPublisher,
-  IPublisherFactoryParams,
-  PublisherError,
-} from '../../types';
+import { ResultDir } from '@ali/lowcode-types';
+import { PublisherFactory, IPublisher, IPublisherFactoryParams, PublisherError } from '../../types';
 import { isNodeProcess, writeZipToDisk, generateProjectZip } from './utils';
 
 // export type ZipBuffer = Buffer | Blob;
@@ -28,7 +23,7 @@ export const createZipPublisher: PublisherFactory<ZipFactoryParams, ZipPublisher
   let { project, outputPath } = params;
 
   const getProject = () => project;
-  const setProject = (projectToSet: IResultDir) => {
+  const setProject = (projectToSet: ResultDir) => {
     project = projectToSet;
   };
 
diff --git a/packages/code-generator/src/publisher/zip/utils.ts b/packages/code-generator/src/publisher/zip/utils.ts
index 54777bb4d..e34bf12c1 100644
--- a/packages/code-generator/src/publisher/zip/utils.ts
+++ b/packages/code-generator/src/publisher/zip/utils.ts
@@ -1,21 +1,17 @@
 import JSZip from 'jszip';
-import { IResultDir, IResultFile } from '../../types';
+import { ResultDir, ResultFile } from '@ali/lowcode-types';
 import { ZipBuffer } from './index';
 
 export const isNodeProcess = (): boolean => {
   return (
-    typeof process === 'object' &&
-    typeof process.versions === 'object' &&
-    typeof process.versions.node !== 'undefined'
+    typeof process === 'object' && typeof process.versions === 'object' && typeof process.versions.node !== 'undefined'
   );
 };
 
-export const writeZipToDisk = (
-  zipFolderPath: string,
-  content: ZipBuffer,
-  zipName: string,
-): void => {
+export const writeZipToDisk = (zipFolderPath: string, content: ZipBuffer, zipName: string): void => {
+  // eslint-disable-next-line @typescript-eslint/no-var-requires
   const fs = require('fs');
+  // eslint-disable-next-line @typescript-eslint/no-var-requires
   const path = require('path');
 
   if (!fs.existsSync(zipFolderPath)) {
@@ -29,7 +25,7 @@ export const writeZipToDisk = (
   writeStream.end();
 };
 
-export const generateProjectZip = async (project: IResultDir): Promise<ZipBuffer> => {
+export const generateProjectZip = async (project: ResultDir): Promise<ZipBuffer> => {
   let zip = new JSZip();
   zip = writeFolderToZip(project, zip, true);
   // const zipType = isNodeProcess() ? 'nodebuffer' : 'blob';
@@ -37,21 +33,17 @@ export const generateProjectZip = async (project: IResultDir): Promise<ZipBuffer
   return zip.generateAsync({ type: zipType });
 };
 
-const writeFolderToZip = (
-  folder: IResultDir,
-  parentFolder: JSZip,
-  ignoreFolder = false,
-) => {
+const writeFolderToZip = (folder: ResultDir, parentFolder: JSZip, ignoreFolder = false) => {
   const zipFolder = ignoreFolder ? parentFolder : parentFolder.folder(folder.name);
   if (zipFolder !== null) {
-    folder.files.forEach((file: IResultFile) => {
+    folder.files.forEach((file: ResultFile) => {
       // const options = file.contentEncoding === 'base64' ? { base64: true } : {};
       const options = {};
       const fileName = file.ext ? `${file.name}.${file.ext}` : file.name;
       zipFolder.file(fileName, file.content, options);
     });
 
-    folder.dirs.forEach((subFolder: IResultDir) => {
+    folder.dirs.forEach((subFolder: ResultDir) => {
       writeFolderToZip(subFolder, zipFolder);
     });
   }
diff --git a/packages/code-generator/src/solutions/rax-app.ts b/packages/code-generator/src/solutions/rax-app.ts
new file mode 100644
index 000000000..c61eae0d4
--- /dev/null
+++ b/packages/code-generator/src/solutions/rax-app.ts
@@ -0,0 +1,66 @@
+import { IProjectBuilder } from '../types';
+
+import { createProjectBuilder } from '../generator/ProjectBuilder';
+
+import esModule from '../plugins/common/esmodule';
+import containerClass from '../plugins/component/rax/containerClass';
+import containerLifeCycles from '../plugins/component/rax/containerLifeCycle';
+import containerMethods from '../plugins/component/rax/containerMethods';
+import containerInitState from '../plugins/component/rax/containerInitState';
+import containerInjectContext from '../plugins/component/rax/containerInjectContext';
+import containerInjectDataSourceEngine from '../plugins/component/rax/containerInjectDataSourceEngine';
+import containerInjectUtils from '../plugins/component/rax/containerInjectUtils';
+import jsx from '../plugins/component/rax/jsx';
+import commonDeps from '../plugins/component/rax/commonDeps';
+import css from '../plugins/component/style/css';
+import constants from '../plugins/project/constants';
+import i18n from '../plugins/project/i18n';
+import utils from '../plugins/project/utils';
+
+import raxApp from '../plugins/project/framework/rax';
+
+import { prettier } from '../postprocessor';
+
+export default function createIceJsProjectBuilder(): IProjectBuilder {
+  return createProjectBuilder({
+    template: raxApp.template,
+    plugins: {
+      components: [
+        commonDeps(),
+        esModule({ fileType: 'jsx', useAliasName: false }),
+        containerClass(),
+        containerInitState(),
+        containerMethods(),
+        containerInjectContext(),
+        containerInjectDataSourceEngine(),
+        containerInjectUtils(),
+        containerLifeCycles(),
+        jsx(),
+        css(),
+      ],
+      pages: [
+        commonDeps(),
+        esModule({ fileType: 'jsx' }),
+        containerClass(),
+        containerInitState(),
+        containerMethods(),
+        containerInjectContext(),
+        containerInjectDataSourceEngine(),
+        containerInjectUtils(),
+        containerLifeCycles(),
+        jsx(),
+        css(),
+      ],
+      appConfig: [raxApp.plugins.appConfig()],
+      buildConfig: [raxApp.plugins.buildConfig()],
+      entry: [raxApp.plugins.entry()],
+      constants: [constants()],
+      utils: [esModule(), utils()],
+      i18n: [i18n()],
+      globalStyle: [raxApp.plugins.globalStyle()],
+      htmlEntry: [raxApp.plugins.entryDocument()],
+      packageJSON: [raxApp.plugins.packageJSON()],
+    },
+    postProcessors: process.env.NODE_ENV !== 'test' ? [prettier()] : [],
+  });
+}
diff --git a/packages/code-generator/src/types/core.ts b/packages/code-generator/src/types/core.ts
index c50d8cd61..8666f507e 100644
--- a/packages/code-generator/src/types/core.ts
+++ b/packages/code-generator/src/types/core.ts
@@ -1,16 +1,24 @@
 import {
-  IBasicSchema,
-  IParseResult,
-  IProjectSchema,
-  IResultDir,
-  IResultFile,
-  IComponentNodeItem,
-  IJSExpression,
-} from './index';
+  JSONArray,
+  JSONObject,
+  CompositeArray,
+  CompositeObject,
+  ResultDir,
+  ResultFile,
+  NodeDataType,
+  ProjectSchema,
+  JSExpression,
+  JSFunction,
+  JSSlot,
+} from '@ali/lowcode-types';
+
+import { IParseResult } from './intermediate';
+import { IScopeBindings } from '../utils/ScopeBindings';
 
 export enum FileType {
   CSS = 'css',
   SCSS = 'scss',
+  LESS = 'less',
   HTML = 'html',
   JS = 'js',
   JSX = 'jsx',
@@ -41,6 +49,7 @@ export interface ICodeChunk {
   subModule?: string;
   content: ChunkContent;
   linkAfter: string[];
+  ext?: Record<string, unknown>;
 }
 
 export interface IBaseCodeStruct {
@@ -69,13 +78,13 @@ export interface ICodeBuilder {
 }
 
 export interface ICompiledModule {
-  files: IResultFile[];
+  files: ResultFile[];
 }
 
 export interface IModuleBuilder {
   generateModule(input: unknown): Promise<ICompiledModule>;
-  generateModuleCode(schema: IBasicSchema | string): Promise<IResultDir>;
-  linkCodeChunks(chunks: Record<string, ICodeChunk[]>, fileName: string): IResultFile[];
+  generateModuleCode(schema: ProjectSchema | string): Promise<ResultDir>;
+  linkCodeChunks(chunks: Record<string, ICodeChunk[]>, fileName: string): ResultFile[];
   addPlugin(plugin: BuilderComponentPlugin): void;
 }
 
@@ -89,21 +98,21 @@ export interface ICodeGenerator {
   /**
    * 出码接口，把 Schema 转换成代码文件系统描述
    *
-   * @param {(IBasicSchema)} schema 传入的 Schema
-   * @returns {IResultDir}
+   * @param {(ProjectSchema)} schema 传入的 Schema
+   * @returns {ResultDir}
    * @memberof ICodeGenerator
    */
-  toCode(schema: IBasicSchema): Promise<IResultDir>;
+  toCode(schema: ProjectSchema): Promise<ResultDir>;
 }
 
 export interface ISchemaParser {
-  validate(schema: IBasicSchema): boolean;
-  parse(schema: IBasicSchema | string): IParseResult;
+  validate(schema: ProjectSchema): boolean;
+  parse(schema: ProjectSchema | string): IParseResult;
 }
 
 export interface IProjectTemplate {
   slots: Record<string, IProjectSlot>;
-  generateTemplate(): IResultDir;
+  generateTemplate(): ResultDir;
 }
 
 export interface IProjectSlot {
@@ -111,25 +120,12 @@ export interface IProjectSlot {
   fileName?: string;
 }
 
-// export interface IProjectSlots {
-//   components: IProjectSlot;
-//   pages: IProjectSlot;
-//   router: IProjectSlot;
-//   entry: IProjectSlot;
-//   constants?: IProjectSlot;
-//   utils?: IProjectSlot;
-//   i18n?: IProjectSlot;
-//   globalStyle: IProjectSlot;
-//   htmlEntry: IProjectSlot;
-//   packageJSON: IProjectSlot;
-// }
-
 export interface IProjectPlugins {
   [slotName: string]: BuilderComponentPlugin[];
 }
 
 export interface IProjectBuilder {
-  generateProject(schema: IProjectSchema | string): Promise<IResultDir>;
+  generateProject(schema: ProjectSchema | string): Promise<ResultDir>;
 }
 
 export type PostProcessorFactory<T> = (config?: T) => PostProcessor;
@@ -140,62 +136,35 @@ export interface IPluginOptions {
   fileDirDepth: number;
 }
 
-export enum PIECE_TYPE {
-  BEFORE = 'NodeCodePieceBefore',
-  TAG = 'NodeCodePieceTag',
-  ATTR = 'NodeCodePieceAttr',
-  CHILDREN = 'NodeCodePieceChildren',
-  AFTER = 'NodeCodePieceAfter',
-}
+export type BaseGenerator<I, T, C> = (input: I, scope: IScope, config?: C, next?: BaseGenerator<I, T, C>) => T;
+type CompositeTypeGenerator<I, T> =
+  | BaseGenerator<I, T, CompositeValueGeneratorOptions>
+  | Array<BaseGenerator<I, T, CompositeValueGeneratorOptions>>;
 
-export interface CodePiece {
-  value: string;
-  type: PIECE_TYPE;
-}
+export type NodeGenerator<T> = (nodeItem: NodeDataType, scope: IScope) => T;
 
+// FIXME: 在新的实现中，添加了第一参数 this: CustomHandlerSet 作为上下文。究其本质
+// scopeBindings?: IScopeBindings;
+// 这个组合只用来用来处理 CompositeValue 类型，不是这个类型的不要放在这里
 export interface HandlerSet<T> {
-  string?: (input: string) => T[];
-  expression?: (input: IJSExpression) => T[];
-  node?: (input: IComponentNodeItem) => T[];
-  common?: (input: unknown) => T[];
+  string?: CompositeTypeGenerator<string, T>;
+  boolean?: CompositeTypeGenerator<boolean, T>;
+  number?: CompositeTypeGenerator<number, T>;
+  expression?: CompositeTypeGenerator<JSExpression, T>;
+  function?: CompositeTypeGenerator<JSFunction, T>;
+  slot?: CompositeTypeGenerator<JSSlot, T>;
+  array?: CompositeTypeGenerator<JSONArray | CompositeArray, T>;
+  object?: CompositeTypeGenerator<JSONObject | CompositeObject, T>;
 }
 
-export type ExtGeneratorPlugin = (ctx: INodeGeneratorContext, nodeItem: IComponentNodeItem) => CodePiece[];
+export type CompositeValueGeneratorOptions = {
+  handlers?: HandlerSet<string>;
+  nodeGenerator?: NodeGenerator<string>;
+};
 
-export interface INodeGeneratorConfig {
-  nodeTypeMapping?: Record<string, string>;
-}
-
-export type NodeGenerator = (nodeItem: IComponentNodeItem) => string;
-
-export interface INodeGeneratorContext {
-  generator: NodeGenerator;
-}
-
-// export interface InteratorScope {
-//   [$item: string]: string;           // $item 默认取值 "item"
-//   [$index: string]: string | number; // $index 默认取值 "index"
-//   __proto__: BlockInstance;
-// }
-
-export type CompositeValueCustomHandler = (data: unknown) => string;
-export type CompositeTypeContainerHandler = (value: string) => string;
-export interface CompositeValueCustomHandlerSet {
-  boolean?: CompositeValueCustomHandler;
-  number?: CompositeValueCustomHandler;
-  string?: CompositeValueCustomHandler;
-  array?: CompositeValueCustomHandler;
-  object?: CompositeValueCustomHandler;
-  expression?: CompositeValueCustomHandler;
-}
-
-export interface CompositeTypeContainerHandlerSet {
-  default?: CompositeTypeContainerHandler;
-  string?: CompositeValueCustomHandler;
-}
-
-export interface CompositeValueGeneratorOptions {
-  handlers?: CompositeValueCustomHandlerSet;
-  containerHandlers?: CompositeTypeContainerHandlerSet;
-  nodeGenerator?: NodeGenerator;
+export interface IScope {
+  // 作用域内定义
+  bindings?: IScopeBindings;
+  // TODO: 需要有上下文信息吗？ 描述什么内容
+  createSubScope: (ownIndentifiers: string[]) => IScope;
 }
diff --git a/packages/code-generator/src/types/deps.ts b/packages/code-generator/src/types/deps.ts
index 02be05592..cb2fb5eac 100644
--- a/packages/code-generator/src/types/deps.ts
+++ b/packages/code-generator/src/types/deps.ts
@@ -34,5 +34,5 @@ export interface IDependency {
   subName?: string; // 下标子组件名称
   main?: string; // 包导出组件入口文件路径 /lib/input
   dependencyType?: DependencyType; // 依赖类型 内/外
-  importName?: string; // 导入后名称
+  componentName?: string; // 导入后名称
 }
diff --git a/packages/code-generator/src/types/error.ts b/packages/code-generator/src/types/error.ts
index 8c0393a88..ff3208c87 100644
--- a/packages/code-generator/src/types/error.ts
+++ b/packages/code-generator/src/types/error.ts
@@ -1,3 +1,4 @@
+/* eslint-disable @typescript-eslint/no-useless-constructor */
 export class CodeGeneratorError extends Error {
   constructor(message: string) {
     super(message);
@@ -5,23 +6,11 @@ export class CodeGeneratorError extends Error {
   }
 }
 
-// tslint:disable-next-line: max-classes-per-file
 export class ComponentValidationError extends CodeGeneratorError {
-  constructor(errorString: string) {
-    super(errorString);
-  }
 }
 
-// tslint:disable-next-line: max-classes-per-file
 export class CompatibilityError extends CodeGeneratorError {
-  constructor(errorString: string) {
-    super(errorString);
-  }
 }
 
-// tslint:disable-next-line: max-classes-per-file
 export class PublisherError extends CodeGeneratorError {
-  constructor(errorString: string) {
-    super(errorString);
-  }
 }
diff --git a/packages/code-generator/src/types/index.ts b/packages/code-generator/src/types/index.ts
index 102515d43..92ca81924 100644
--- a/packages/code-generator/src/types/index.ts
+++ b/packages/code-generator/src/types/index.ts
@@ -1,7 +1,6 @@
 export * from './core';
 export * from './deps';
 export * from './error';
-export * from './result';
-export * from './schema';
 export * from './intermediate';
 export * from './publisher';
+export * from './jsx';
diff --git a/packages/code-generator/src/types/intermediate.ts b/packages/code-generator/src/types/intermediate.ts
index 317ef7843..11e6cc7b3 100644
--- a/packages/code-generator/src/types/intermediate.ts
+++ b/packages/code-generator/src/types/intermediate.ts
@@ -1,49 +1,51 @@
-import {
-  IAppConfig,
-  IAppMeta,
-  IContainerNodeItem,
-  IDependency,
-  II18nMap,
-  IInternalDependency,
-  INpmPackage,
-  IUtilItem,
-} from './index';
+import { I18nMap, UtilsMap, ContainerSchema, JSONObject } from '@ali/lowcode-types';
+
+import { IDependency, INpmPackage } from './deps';
 
 export interface IParseResult {
   containers: IContainerInfo[];
   globalUtils?: IUtilInfo;
-  globalI18n?: II18nMap;
+  globalI18n?: I18nMap;
   globalRouter?: IRouterInfo;
   project?: IProjectInfo;
 }
 
-export interface IContainerInfo extends IContainerNodeItem, IWithDependency {
-  containerType: string;
-  moduleName: string;
-}
-
 export interface IWithDependency {
   deps?: IDependency[];
 }
 
+export interface IContainerInfo extends ContainerSchema, IWithDependency {
+  containerType: string;
+  moduleName: string;
+}
+
 export interface IUtilInfo extends IWithDependency {
-  utils: IUtilItem[];
+  utils: UtilsMap;
 }
 
 export interface IRouterInfo extends IWithDependency {
   routes: Array<{
     path: string;
+    fileName: string;
     componentName: string;
   }>;
 }
 
 export interface IProjectInfo {
-  config: IAppConfig;
-  meta: IAppMeta;
   css?: string;
-  constants?: Record<string, string>;
-  i18n?: II18nMap;
+  containersDeps?: IDependency[];
+  utilsDeps?: IDependency[];
+  constants?: JSONObject;
+  i18n?: I18nMap;
   packages: INpmPackage[];
+  meta?: {
+    name?: string;
+    title?: string;
+  };
+}
+
+export interface IPageMeta {
+  router?: string;
 }
 
 /**
diff --git a/packages/code-generator/src/types/jsx.ts b/packages/code-generator/src/types/jsx.ts
new file mode 100644
index 000000000..6ec5c7fef
--- /dev/null
+++ b/packages/code-generator/src/types/jsx.ts
@@ -0,0 +1,29 @@
+import { NodeSchema, CompositeValue } from '@ali/lowcode-types';
+import { HandlerSet, BaseGenerator, NodeGenerator } from './core';
+
+export enum PIECE_TYPE {
+  BEFORE = 'NodeCodePieceBefore',
+  TAG = 'NodeCodePieceTag',
+  ATTR = 'NodeCodePieceAttr',
+  CHILDREN = 'NodeCodePieceChildren',
+  AFTER = 'NodeCodePieceAfter',
+}
+
+export interface CodePiece {
+  name?: string;
+  value: string;
+  type: PIECE_TYPE;
+}
+
+export type AttrData = { attrName: string; attrValue: CompositeValue };
+// 对 JSX 出码的理解，目前定制点包含 【包装】【标签名】【属性】
+export type AttrPlugin = BaseGenerator<AttrData, CodePiece[], NodeGeneratorConfig>;
+export type NodePlugin = BaseGenerator<NodeSchema, CodePiece[], NodeGeneratorConfig>;
+
+export type NodeGeneratorConfig = {
+  handlers?: HandlerSet<string>;
+  tagMapping?: (input: string) => string;
+  attrPlugins?: AttrPlugin[];
+  nodePlugins?: NodePlugin[];
+  self?: NodeGenerator<string>;
+};
diff --git a/packages/code-generator/src/types/publisher.ts b/packages/code-generator/src/types/publisher.ts
index a632e4d9b..53e4df9fd 100644
--- a/packages/code-generator/src/types/publisher.ts
+++ b/packages/code-generator/src/types/publisher.ts
@@ -1,17 +1,15 @@
-import {
-  IResultDir,
-} from './index';
+import { ResultDir } from '@ali/lowcode-types';
 
 export type PublisherFactory<T, U> = (configuration?: Partial<T>) => U;
 
 export interface IPublisher<T, U> {
   publish: (options?: T) => Promise<IPublisherResponse<U>>;
-  getProject: () => IResultDir | void;
-  setProject: (project: IResultDir) => void;
+  getProject: () => ResultDir | void;
+  setProject: (project: ResultDir) => void;
 }
 
 export interface IPublisherFactoryParams {
-  project?: IResultDir;
+  project?: ResultDir;
 }
 export interface IPublisherResponse<T> {
   success: boolean;
diff --git a/packages/code-generator/src/utils/OrderedSet.ts b/packages/code-generator/src/utils/OrderedSet.ts
new file mode 100644
index 000000000..3c58ddc73
--- /dev/null
+++ b/packages/code-generator/src/utils/OrderedSet.ts
@@ -0,0 +1,33 @@
+export class OrderedSet<T> {
+  private _set = new Set<T>();
+  private _arr: T[] = [];
+
+  constructor(items?: T[]) {
+    if (items) {
+      this._set = new Set(items);
+      this._arr = items.slice(0);
+    }
+  }
+
+  add(item: T) {
+    if (!this._set.has(item)) {
+      this._set.add(item);
+      this._arr.push(item);
+    }
+  }
+
+  delete(item: T) {
+    if (this._set.has(item)) {
+      this._set.delete(item);
+      this._arr.splice(this._arr.indexOf(item), 1);
+    }
+  }
+
+  has(item: T) {
+    return this._set.has(item);
+  }
+
+  toArray() {
+    return this._arr.slice(0);
+  }
+}
diff --git a/packages/code-generator/src/utils/Scope.ts b/packages/code-generator/src/utils/Scope.ts
new file mode 100644
index 000000000..e8b7bf235
--- /dev/null
+++ b/packages/code-generator/src/utils/Scope.ts
@@ -0,0 +1,27 @@
+import { IScope } from '../types/core';
+import { IScopeBindings, ScopeBindings } from './ScopeBindings';
+
+class Scope implements IScope {
+  static createRootScope(): IScope {
+    return new Scope();
+  }
+
+  bindings?: IScopeBindings;
+
+  constructor() {
+    this.bindings = undefined;
+  }
+
+  createSubScope(ownIndentifiers: string[]): IScope {
+    const originalScopeBindings = this.bindings;
+    const newScopeBindings = new ScopeBindings(originalScopeBindings);
+    ownIndentifiers.forEach((identifier) => {
+      newScopeBindings.addBinding(identifier);
+    });
+    const newScope = new Scope();
+    newScope.bindings = newScopeBindings;
+    return newScope;
+  }
+}
+
+export default Scope;
diff --git a/packages/code-generator/src/utils/ScopeBindings.ts b/packages/code-generator/src/utils/ScopeBindings.ts
new file mode 100644
index 000000000..875f6c82e
--- /dev/null
+++ b/packages/code-generator/src/utils/ScopeBindings.ts
@@ -0,0 +1,56 @@
+import { OrderedSet } from './OrderedSet';
+
+export interface IScopeBindings {
+  readonly parent: IScopeBindings | null;
+
+  hasBinding(varName: string): boolean;
+  hasOwnBinding(varName: string): boolean;
+
+  addBinding(varName: string): void;
+  removeBinding(varName: string): void;
+
+  getAllBindings(): string[];
+  getAllOwnedBindings(): string[];
+}
+
+export class ScopeBindings implements IScopeBindings {
+  readonly parent: IScopeBindings | null;
+
+  private _bindings = new OrderedSet<string>();
+
+  constructor(p: IScopeBindings | null = null) {
+    this.parent = p;
+  }
+
+  hasBinding(varName: string): boolean {
+    return this._bindings.has(varName) || !!this.parent?.hasBinding(varName);
+  }
+
+  hasOwnBinding(varName: string): boolean {
+    return this._bindings.has(varName);
+  }
+
+  addBinding(varName: string): void {
+    this._bindings.add(varName);
+  }
+
+  removeBinding(varName: string): void {
+    this._bindings.delete(varName);
+  }
+
+  getAllBindings(): string[] {
+    const allBindings = new OrderedSet(this._bindings.toArray());
+
+    for (let parent = this.parent; parent; parent = parent?.parent) {
+      parent.getAllOwnedBindings().forEach((varName) => {
+        allBindings.add(varName);
+      });
+    }
+
+    return allBindings.toArray();
+  }
+
+  getAllOwnedBindings(): string[] {
+    return this._bindings.toArray();
+  }
+}
diff --git a/packages/code-generator/src/utils/aopHelper.ts b/packages/code-generator/src/utils/aopHelper.ts
new file mode 100644
index 000000000..2b380c648
--- /dev/null
+++ b/packages/code-generator/src/utils/aopHelper.ts
@@ -0,0 +1,28 @@
+import { BaseGenerator, IScope } from '../types/core';
+
+export function executeFunctionStack<I, T, C>(
+  input: I,
+  scope: IScope,
+  funcs: BaseGenerator<I, T, C> | Array<BaseGenerator<I, T, C>>,
+  baseFunc: BaseGenerator<I, T, C>,
+  config?: C,
+): T {
+  const funcList: Array<BaseGenerator<I, T, C>> = [];
+  if (Array.isArray(funcs)) {
+    funcList.push(...funcs);
+  } else {
+    funcList.push(funcs);
+  }
+
+  let next: BaseGenerator<I, T, C> = baseFunc;
+  while (funcList.length > 0) {
+    const func = funcList.pop();
+    if (func) {
+      const warppedFunc =
+        ((nextFunc) => (i: I, s: IScope, cfg?: C) => func(i, s, cfg, nextFunc))(next);
+      next = warppedFunc;
+    }
+  }
+
+  return next(input, scope, config);
+}
diff --git a/packages/code-generator/src/utils/common.ts b/packages/code-generator/src/utils/common.ts
index 5d4619cdb..fe05ce423 100644
--- a/packages/code-generator/src/utils/common.ts
+++ b/packages/code-generator/src/utils/common.ts
@@ -24,7 +24,9 @@ export function upperCaseFirst(inputValue: string): string {
 
 export function uniqueArray<T>(arr: T[], by: (i: T) => string) {
   const map: Record<string, T> = {};
-  arr.forEach((item) => (map[by(item)] = item));
+  arr.forEach((item) => {
+    map[by(item)] = item;
+  });
   const uniqueKeys = [...new Set<string>(Object.keys(map))];
   const uniqueItems = uniqueKeys.map((key) => map[key]);
   return uniqueItems;
